【原创】leetCodeOj --- Jump Game II 解题报告

原题地址:

https://oj.leetcode.com/problems/jump-game-ii/

题目内容:

Given an array of non-negative integers, you are initially positioned at the first index of the array.

Each element in the array represents your maximum jump length at that position.

Your goal is to reach the last index in the minimum number of jumps.

For example:
Given array A = [2,3,1,1,4]

The minimum number of jumps to reach the last index is 2. (Jump 1 step from index 0 to 1, then 3 steps to the last index.)

方法:

这里比较微妙,尽管用dp硬解和用贪心的复杂度都是O(n^2),但贪心有常数上的优势,也的确ac了。用dp硬解则是TLE。

首先初始化终点fin为n - 1,然后从头开始,找到第一个能到达终点的点,并把终点更新为该点,同时步数加1。因为该点离终点只有一步之遥,所以经过该点到终点步数最短。

重复直到fin为0

全部代码:

class Solution {
public:
int jump(int A[], int n) {
if (n == )
return ;
int fin = n - ;
int step = ;
while (fin != )
{
for (int i = ;i < fin;i++)
{
if (A[i] >= fin - i)
{
fin = i;
step ++;
break;
}
}
}
return step;
}
};
上一篇:【Hive】Spark引擎Group By带分区字段,执行计划reduce个数计算异常


下一篇:ElasticSearch入门 第一篇:Windows下安装ElasticSearch